#include "hmg.ch"
#include "hmg_BoxLetterShow.ch"
#include "Encripta.prg"
#include "GeneraTXT.prg"
#include "Newclave.prg"

  Function Main

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )
  
*----------------------------------* 

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  

*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET INTERACTIVECLOSE ON
*----------------------------------* 
  PUBLIC cFileName 
  PUBLIC cFileD , Cfile
*-----------------------------------------------------------------*   
  Public  CONTRA  , CONTRAS
  Public  CON     , CONS
  Public  CRISUA  , CRISUAS
  Public  LARGO   , LARGOS
*-----------------------------------------------------------------*   
  Public cContenido , cContenidox
  Public cPrgFolder := GetCurrentFolder() 
  Public ficher  := "MASTER"
  PUBLIC xCRIPTO1 
  PUBLIC xCRIPTO2
  PUBLIC CRIPTO  := "ENIGMA" 
  PUBLIC a_NomC  := "TEXTO"

*-----------------------------------------------------------------*   

  FileDelete("MASTER_c.*")
  FileDelete("MASTER_d.*")

*-----------------------------------------------------------------* 

 IF .NOT. FILE('xControl.mem')

      password_control()  

  ELSE

     RESTORE FROM xControl.mem  ADDITIVE
    
  ENDIF

*-----------------------------------------------------------------* 

   nWindWidth  := 992
   nWindHeight := 735
   
   nUnMWinCol := ( GetDesktopWidth() - nWindWidth ) / 2
   nUnMWinRow := ( GetDesktopHeight() - nWindHeight ) / 2
    

         DEFINE WINDOW Form_1              ;           
		AT 0,0                     ;
		WIDTH 992 HEIGHT 735       ;  
		TITLE "Crypto_Documents"   ;
                ICON 'Logo'                ; 
                NOSIZE TOPMOST NOMINIMIZE NOMAXIMIZE ;  
                MAIN                       ;
		FONT "Arial" SIZE 10 BACKCOLOR { 211,218,236 } ;
                ON INIT password_control()  ; 
                ON INTERACTIVECLOSE {||.F. }
                ON KEY ESCAPE ACTION Exit_Segury()        
 

          DEFINE TIMER Timer_1Q ;
                 INTERVAL 100 ;
                 ACTION { || thisWindow.Row := nUnMWinRow, thisWindow.Col := nUnMWinCol }

 
*-----------------------------------------------------------------------*


        BoxBoxNoColor( 31 , 661 , 294 , 73, "18xShi",.T.  )   

                    Form_1.Label_18xShi.Enabled := .F.

       @ 35,666 LABEL Label_00 VALUE "" CENTERALIGN ;
               FONT "Arial" SIZE 17 BOLD ITALIC BACKCOLOR {023,101,012} FONTCOLOR {255,016,014} ;
               WIDTH 285 HEIGHT 65 


       @ 53,666 LABEL Label_01 VALUE "Crypto_Documents" CENTERALIGN ;
               FONT "Arial" SIZE 18 BOLD ITALIC BACKCOLOR {023,101,012} FONTCOLOR {255,016,014} ;
               WIDTH 285 HEIGHT 30  


*-----------------------------------------------------------------------------------------------------------------*
*------------------------------------------------  Cuadro Adorno Egipto ------------------------------------------*

     NewBoxShadow( 135, 689, 246, 196 ,"13hi" ,"14hi","15hi", .T. , .F. , .T., 016,000,100 , 128,126,255 )  

                     Form_1.Label_13hi.Enabled := .F.    // <---- Necesario si ponemos MONTHCALENDAR  TEXTBOX
                     Form_1.Label_14hi.Enabled := .F.    // <---- Necessary if we MonthCalendar or TEXTBOX
                     Form_1.Label_15hi.Enabled := .F.    // <---- Necessary if we MonthCalendar or TEXTBOX
*-----------------------------------------------------------------------------------------------------------------*
     
     BoxBox( 136 , 690 , 235 , 185, "16xhi",.T.,  253, 209, 209  )   // <-----   Box Undido ----> BORDER CLIENTEDGE     

                     Form_1.Label_16xhi.Enabled := .F.

*-----------------------------------------------------------------------------------------------------------------*

    DEFINE IMAGE ImagePhoto  
        ROW    144  
        COL    700 
        WIDTH  215  
        HEIGHT 167  
        PICTURE 'Resource\Cripto3.jpg'   
        HELPID Nil
        VISIBLE .T.
        STRETCH .F.
        ACTION Nil
    END IMAGE

*----------------------------------------------  END Cuadro Adorno Egipto-----------------------------------------*

*-----------------------------------------------------------------------------------------------------------------*

     NewBoxShadow( 038, 028, 605, 300 ,"16hi" ,"17hi","18hi", .T. , .F. , .T., 016,000,100 , 128,126,255 )  

                      Form_1.Label_16hi.Enabled := .F.    // <---- Necesario si ponemos MONTHCALENDAR  TEXTBOX
                      Form_1.Label_17hi.Enabled := .F.    // <---- Necessary if we MonthCalendar or TEXTBOX
                      Form_1.Label_18hi.Enabled := .F.    // <---- Necessary if we MonthCalendar or TEXTBOX

 *----------------------------------------------------------------------------------------------------------------*   
  
        BoxBoxNoColor( 039 , 029 , 594 , 289, "17xhi",.T.  )  

                      Form_1.Label_17xhi.Enabled := .F.

*-----------------------------------------------------------------------------------------------------------------*

    DEFINE EDITBOX Edit_1
        ROW    040 	
        COL    030
        WIDTH  590  
        HEIGHT 285
        VALUE cContenido        
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .F.  
        VISIBLE .T.
        READONLY .T.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
        BACKCOLOR nil  
        FONTCOLOR nil 
    END EDITBOX

*---------------------------------------------------------------------------*

    DEFINE LABEL Name_1a
          ROW   010  
          COL   178  
          WIDTH 125 
          HEIGHT 20
          BACKCOLOR { 211,218,236 } 
          VALUE 'File Name:' 
          FONTBOLD .T.
    END LABEL
  
    DEFINE LABEL Name_1b
          ROW   010  
          COL   260  
          WIDTH 300
          HEIGHT 20
          BACKCOLOR { 211,218,236 } 
          FONTBOLD .T.
    END LABEL

*-----------------------------------------------------------------------------------------------------------------*

    NewBoxShadow( 383, 028, 605, 305 ,"19hi" ,"20hi","21hi", .T. , .F. , .T., 016,000,100 , 128,126,255 )  

                     Form_1.Label_19hi.Enabled := .F.    // <---- Necesario si ponemos MONTHCALENDAR  TEXTBOX
                     Form_1.Label_20hi.Enabled := .F.    // <---- Necessary if we MonthCalendar or TEXTBOX
                     Form_1.Label_21hi.Enabled := .F.    // <---- Necessary if we MonthCalendar or TEXTBOX

*-----------------------------------------------------------------------------------------------------------------*

        BoxBoxNoColor( 384 , 029 , 594 , 294, "18xhi",.T.  ) 
  
                      Form_1.Label_18xhi.Enabled := .F.

*-----------------------------------------------------------------------------------------------------------------*

    DEFINE EDITBOX Edit_2
        ROW    385  
        COL    030
        WIDTH  590  
        HEIGHT 290  
        VALUE ""    
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
        BACKCOLOR Nil
        FONTCOLOR Nil
    END EDITBOX

    DEFINE LABEL Name_2a
         ROW   350 
         COL   178  
         WIDTH 125 
         HEIGHT 20
         BACKCOLOR { 211,218,236 } 
         VALUE 'File Name:' 
         FONTBOLD .T.
    END LABEL
  
    DEFINE LABEL Name_2b
         ROW   350
         COL   260  
         WIDTH 300
         HEIGHT 20
         BACKCOLOR { 211,218,236 } 
         FONTBOLD .T.
    END LABEL

*------------------------------------------------------------------*
  
      DEFINE BUTTON SourceBtn
         ROW    345   
         COL    710  
         WIDTH  200
         HEIGHT 028
         PICTURE 'Resource\Search.bmp'
         CAPTION 'Select the source file'
         TOOLTIP 'Select the source file' 
         ACTION BuscaFichero()  
         FONTBOLD .T.  
         PICTALIGNMENT LEFT
      END BUTTON
    
*------------------------------------------------------------------*

               @ 380,755 BUTTON Encrypt              ;         
                         CAPTION 'Encrypted'         ;  
                         PICTURE 'Resource\ICrip3M.bmp'  ;  
                         FONT "Arial" SIZE 9 BOLD ITALIC ;           
                         TOOLTIP 'Encrypted Document';                                      
                         WIDTH 105 HEIGHT 54         ; 
                         ACTION TextoGrabaCrip()  
          
               @ 445,755 BUTTON Decrypt              ;    
                         CAPTION 'Decrypted'         ; 
                         PICTURE 'Resource\ICrip2M.bmp'  ; 
                         FONT "Arial" SIZE 9 BOLD ITALIC ; 
                         TOOLTIP 'Decrypted Document';                                      
                         WIDTH 105 HEIGHT 54         ; 
                         ACTION BuscaFichero_D()                

               @ 510,755 BUTTON limpiax              ;   
                         CAPTION 'Clean'             ;  
                         PICTURE 'Resource\Clean.bmp' ;   
                         FONT "Arial" SIZE 9 BOLD ITALIC ;               
                         TOOLTIP 'Clean Up Documens' ; 
                         WIDTH 105 HEIGHT 54         ; 
                         ACTION  Limpia()    

               @ 575,755 BUTTON NewKey               ;   
                         CAPTION 'New Key'           ;  
                         PICTURE 'Resource\Key.bmp'  ; 
                         FONT "Arial" SIZE 9 BOLD ITALIC ;                   
                         TOOLTIP 'New Key...'        ; 
                         WIDTH 105 HEIGHT 54         ; 
                         ACTION NEWCLAVE()             

               @ 640,755 BUTTON Salir                ;     
                         CAPTION 'Exit'              ;  
                         PICTURE 'Resource\Exit.bmp' ;   
                         FONT "Arial" SIZE 9 BOLD ITALIC ;               
                         TOOLTIP 'Exit ...'          ; 
                         WIDTH 105 HEIGHT 54         ; 
                         ACTION Exit_Segury()                 


  END WINDOW

    SETWINDOWCURSOR ( Form_1.SourceBtn.Handle, "resource\finger.cur")

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

Return Nil


*-------------------------------------------*
Procedure Exit_Segury()
*-------------------------------------------*

   FileDelete("MASTER_c.*")
   FileDelete("MASTER_d.*")

   Form_1.Release

  Return Nil

*-------------------------------------------*
Procedure BuscaFichero()
*-------------------------------------------*

 Form_1.Edit_1.value := ""
 Form_1.Edit_2.value := ""

 
 Public cFileD := GetFile({{'txt','*.txt'},{'All files','*.*'}})

 SetCurrentFolder( cPrgFolder )

 IF .NOT. FILE (cFileD)
      msginfo("Not Elected File"," Attention !!!")
     RETURN
 ENDIF

 cContenido := MEMOREAD( cFileD )

 
 *--------------  File + ".txt" =  Calculo Digitos -------------------*

  ficheraax := LEFT( cFileD , LEN(cFileD) ) 

  nPos := RAT("\", cFileD) 

  ficheraaxA  = SUBSTR(cFileD, 1, nPos) 

 *--------------------------------------------------------------------*

  ficheraax := RIGHT( cFileD , LEN(cFileD) - RAT("\", cFileD ))  

 *---------------  Solo File  =  Calculo Digitos ---------------------*

  Nuevo =  LEFT ( ficheraax , LEN( ficheraax ) - 4 ) 
     

  Form_1.Name_1b.VALUE :=  Nuevo + ".txt"

  Form_1.Edit_1.value:=cContenido

 RETURN

*-------------------------------------------*
  Procedure TextoGrabaCrip()
*-------------------------------------------*

  cContenido := Form_1.Edit_1.value

  cContenidoX :=  Cript ( Form_1.Edit_1.value , CRIPTO )   

*--------------------------------- Nom Listado txt -----------------------------------------*

  FDIA   := DTOC(DATE()) 
  FDIAx  := STRTRAN(FDIA, '/')    && <--------  eliminas la barra(/) 
  HORA   := LEFT(TIME(), 5) 
  HORAx  := STRTRAN(HORA, ':')    && <--------  eliminas los dos puntos(:) 
  cNombre:= "Doc_Encrypted\" + "Encrypted" + "_" + FDIAx + '_' + HORAx + '.txt' 
  cNumero:=  (  FDIAx  + '_' +  HORAx )

*--------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------*

  Form_1.Name_2b.VALUE := SUBSTR(cNombre , 15)  

  IF MEMOWRIT( cNombre ,cContenidoX,.T.)

    ELSE
      msginfo("Could not Write File","Attention !!!")
     RETURN
  ENDIF

*----------------------------------------------------------------------*

 CLOSE DATABASES
 SELECT 1
 USE MASTER
 ZAP
 CLOSE DATABASES
 SELECT 1
 USE MASTER
 APPEND BLANK                              
 REPLACE TEXTO     WITH cContenido

*--------------------------------------------------*
 
  SELECT 1
  USE MASTER        

  DO WHILE MASTER->( !Eof() )    
  
          SELECT MASTER
          
          REPLACE TEXTO     WITH  Cript ( TEXTO , CRIPTO )  
          MASTER ->( DbSkip() )
               
  ENDDO


 IF .NOT. FILE (cFileD)

     MsgInfo('Select the source file !!!','Select Document') 
     RETURN

  ELSE

    MsgInfo('Encrypted Document  Ok !!!','Encrypted Document') 

  ENDIF

  CLOSE DATABASES

  SELECT 1
  USE MASTER
  COPY TO MASTER_c

  CLOSE DATABASES

 BuscaFichero_Cz()

 RETURN

*-------------------------------------------*
Procedure BuscaFichero_Cz()
*-------------------------------------------*

CLOSE DATABASES

SELECT 1
USE MASTER_c

Form_1.Edit_2.Value  := TEXTO

CLOSE DATABASES

RETURN

*-------------------------------------------*
Procedure BuscaFichero_D()
*-------------------------------------------*

  CLOSE DATABASES

  SELECT 1
  USE MASTER
  COPY TO MASTER_d  
  
  CLOSE DATABASES

  SELECT 1
  USE MASTER_d


  DO WHILE MASTER_d->( !Eof() )    
  
          SELECT MASTER_d
          
          REPLACE TEXTO     WITH  DeCript ( TEXTO , CRIPTO )  
          MASTER_d ->( DbSkip() )
               
  ENDDO


 IF .NOT. FILE (cFileD)

     MsgInfo('Select the source file !!!','Select Document') 
     RETURN
  ELSE

     MsgInfo('Decrypted Document Ok !!!','Decrypted Document') 

  ENDIF


CLOSE DATABASES

*--------------------------------------------------------------------------*

 SELECT 1
 USE MASTER_d

 Form_1.Edit_2.Value  := TEXTO

 CLOSE DATABASES
 
 Form_1.Name_2b.VALUE  :="" 

 Genera_TxT()

 Form_1.Name_2b.VALUE := SUBSTR(cNombreX , 15)  

RETURN

*-------------------------------------------*
Procedure Limpia()
*-------------------------------------------*

Close Databases

 Form_1.Name_1b.VALUE  :="" 
 Form_1.Name_2b.VALUE  :="" 
 Form_1.Edit_1.value   :=""
 Form_1.Edit_2.value   :=""


RETURN

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*---------------------------------*
Function  password_control()   
*---------------------------------*

  PUBLIC una:= 0
  una := 0

  SAVE TO zControl.mem ALL LIKE una*

*----------------------------------------*
*----------------------------------------*

 *---------------------------------------*   
 * Public  CONTRA  , CONTRAS
 * Public  CON     , CONS
 * Public  CRISUA  , CRISUAS
 * Public  LARGO   , LARGOS
 *---------------------------------------*  


*----------------------------------------*

 IF .NOT. FILE('xControl.mem')
    
  CONTRA  := ALLTRIM(UPPER("admin"))  
  CON     := CONTRA
  CRISUA  := CON
  LARGO   := LEN(CONTRA)
   
 *------------------------* 

  CONTRAS  := ALLTRIM(UPPER("admin"))  
  CONS     := CONTRAS
  CRISUAS  := CONS
  LARGOS   := LEN(CONTRAS)
   

   xCRIPTO1 =' '

   i=1

   lugar  :=largo

   DO WHILE i<=largo
          sumar=asc(substr(crisua,lugar,1))
          xcripto1=xcripto1+chr(asc(substr(UPPER(contra),i,1))+sumar)
          i=i+1
          if lugar>=6
                 lugar=1
          else
                 lugar=lugar+1
          endif
   ENDDO
   
   xCRIPTO2 =' '

   iS=1

   lugarS  :=largoS

   DO WHILE iS<=largoS
          sumar=asc(substr(crisuaS,lugarS,1))
          xcripto2=xcripto2+chr(asc(substr(UPPER(contraS),iS,1))+sumar)
          iS=iS+1
          if lugarS>=6
                 lugarS=1
          else
                 lugarS=lugarS+1
          endif
   ENDDO

   save all like xcriptO* to xControl 

   RETURN

ENDIF

*------------------------------------------------------------------*

 
   nWindWidth2  := 280
   nWindHeight2 := 159
   
   nUnMWinCol2 := ( GetDesktopWidth() - nWindWidth2 ) / 2
   nUnMWinRow2 := ( GetDesktopHeight() - nWindHeight2 ) / 2
    
    
   DEFINE WINDOW Form_1q              ;
       AT 460,372                     ;
       WIDTH 280 HEIGHT 162           ;
       TITLE "Pasword Access"         ; 
       MODAL NOSIZE NOSYSMENU CURSOR ""   
       ON KEY ALT+F4 ACTION MsgStop( 'Alt+F4 - Not Allowed', ' Attention !!!')
       ON KEY ESCAPE ACTION ( Form_1q.Release , Exit_Segury() )  


         DEFINE TIMER Timer_2Q ;
                 INTERVAL 100 ;
                 ACTION { || thisWindow.Row := nUnMWinRow2, thisWindow.Col := nUnMWinCol2 }

    
*----------------------------------------------*

    DEFINE IMAGE Image_1q
        ROW    34
        COL    22
        WIDTH  32
        HEIGHT 32
        PICTURE "resource\Acceso1.jpg"
        HELPID Nil
        VISIBLE .T.
        STRETCH .F.
        ACTION Nil
    END IMAGE

*----------------------------------------------*
   
    DEFINE LABEL Label_2q
        ROW    36
        COL    75
        WIDTH  60
        HEIGHT 24
        VALUE "Password"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Enter Password"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR Nil
        FONTCOLOR Nil
    END LABEL

    DEFINE TEXTBOX Texto_02q
        ROW    35
        COL    150
        WIDTH  100
        HEIGHT 23
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Enter Password"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        PASSWORD .T.
        BACKCOLOR {180,200,255}      
        FONTCOLOR Nil
        INPUTMASK Nil
        MAXLENGTH 8            
        FORMAT Nil
        VALUE ""
        UPPERCASE .F.   
    END TEXTBOX

    DEFINE BUTTON Button_1q
        ROW    90
        COL    26
        WIDTH  105
        HEIGHT 28
        CAPTION "&Accept"   
        ACTION verUsuariow()
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Aceptar"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Acep.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

    DEFINE BUTTON Button_2q      
        ROW    90
        COL    150
        WIDTH  105
        HEIGHT 28
        CAPTION "&Cancel"   
        ACTION ( Form_1q.Release , Exit_Segury() )   
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Cancelar"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Cancel.bmp"
        PICTALIGNMENT LEFT
     END BUTTON

   END WINDOW
  
  Form_1q.Texto_02q.Enabled := .T.
  Form_1q.Texto_02q.SetFocus

       CENTER WINDOW Form_1q  
       Form_1q.Activate   

 RETURN NIL
 *---------------------------------*
 FUNCTION verUsuariow() 
*----------------------------------*

  RESTORE FROM xControl.mem  ADDITIVE

    CONTRA  := ALLTRIM(UPPER(Form_1q.Texto_02q.value))  
    CON     := CONTRA
    CRISUA  := CON
    LARGO   := LEN(CONTRA)



    CONTRAS  := ALLTRIM(UPPER(Form_1q.Texto_02q.value))  
    CONS     := CONTRAS
    CRISUAS  := CONS
    LARGOS   := LEN(CONTRAS)
    
 * -----------------------------------------------------------------------------------------------*
   
   if largo<>0
            ixcripto1=' '
            i=1
            lugar=largo
            DO WHILE i<=largo  
                     sumar=asc(substr(crisua,lugar,1))
                     ixcripto1=ixcripto1+chr(asc(substr(UPPER(contra),i,1))+sumar)  
                     i=i+1
                     if lugar>=6
                            lugar=1
                     else
                            lugar=lugar+1
                     endif
            ENDDO


            ixcripto2=' '
            iS=1
            lugarS=largoS
            DO WHILE is<=largos  
                     sumars=asc(substr(crisuas,lugarS,1))
                     ixcripto2=ixcripto2+chr(asc(substr(UPPER(contraS),iS,1))+sumars)  
                     iS=iS+1
                     if lugarS>=6
                            lugarS=1
                     else
                            lugarS=lugarS+1
                     endif
            ENDDO


            if xcripto1==ixcripto1 .And. xcripto2==ixcripto2
                     notedejo=.f.

                     MsgInfo('Password Correct','Password') 
               
                    
                     Form_1q.Texto_02q.value := ""  
                     Form_1q.Release 
                   
               else
                     notedejo=.t.

                     RESTORE FROM ZControl.mem ADDITIVE 
    
                     MsgStop('Password Incorrect'+CRLF ;
                     +'intent n : '+ SPACE(1) + ALLTRIM(STR(una+1)) ,'Password !!!') 
                  
                     Form_1q.Texto_02q.value := "" 
              
                     ContadorSq() 
                       
            endif
   endif      
 
 
  RETURN NIL

* --------------------------------------------------------------------*

*---------------------------------*
PROCEDURE ContadorSq() 
*---------------------------------*

  una = una + 1
  SAVE TO zControl.mem ALL LIKE una* 

  RESTORE FROM zControl.mem ADDITIVE

  IF una >= 3  
    MsgStop('Not Allow more Attempts','Warning!!!')

           una = 0
           SAVE TO zControl.mem ALL LIKE una*
           ( Form_1q.Release , Form_1.release ) 

   RETURN NIL 

ENDIF


RETURN NIL 


*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*






































